unit Unit3;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm3 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation
{$R *.DFM}
uses
  CORBA, OrbPas30, CorbaObj, BobNotes_I, BobNotes_C;

procedure TForm3.Button1Click(Sender: TObject);
var
  Factory: CorBobNotesFactory;
  Client: ICorBobNotes;
  Lines: WideString;
begin
  Factory := TCorBobNotesFactoryHelper.Bind('CorBobNotes');
  Client := Factory.CreateInstance('CorBobNotes');
  Client.GetLines('Bob','swart',Lines);
  Memo1.Lines.Add(Lines);
  Client := nil;
  Factory := nil
end;

procedure TForm3.Button2Click(Sender: TObject);
var
  Factory,Client: TAny;
  Lines: WideString;
  User,Pass: WideString;
begin
  Factory := Orb.Bind('IDL:BobNotes/CorBobNotesFactory:1.0');
  Client := Factory.CreateInstance('CorBobNotes');
  User := 'Bob';
  Pass := 'swart';
  Client.GetLines(User,Pass,Lines);
  Memo1.Lines.Add(Lines);
  Client := unassigned;
  Factory := unassigned;
end;

end.
